*-----------------------------------------------------------------------
*-- This tool is used to record the time during benchmarking
*-- 
*-- pc_bgnend  : "B" for start recording time "E" for end recording and put in database
*-- pc_event : description of event
*-- pc_case : sub cases in the event
*-- pl_dspwait : to display wait wind before and after recording time
*-- pc_tstdat : Notes
*--
*--	To use it
*--	1. Copy both the files bmark.prg/dbf into the current directory

*--	2.call in the start point like
*--	DO BMARK WITH "B", "sopost form loading", "local-as is", .t.

*--	3.call in the end point like
*--	DO BMARK WITH "B", "sopost form loading", "local-as is", .t.
*-----------------------------------------------------------------------
PARAMETERS pc_bgnend, pc_event, pc_case, pl_dspwait, pc_tstdat

IF pc_bgnend = "B"

  IF NOT USED("BMARK")
    USE BMARK IN 0
  ENDIF

  IF TYPE("gn_begintime") = "U"
    PUBLIC gn_begintime
  ENDIF

  IF pl_dspwait
    WAIT wind "Begin time recording starts after this..." NOWAIT
  ENDIF

  gn_begintime = SECONDS()
ELSE
  ln_ensec = SECONDS()
  
  *-- If test data category is not specified set it to null
  IF TYPE('pc_tstdat') = "L"
    pc_tstdat = ""
  ENDIF
  
  INSERT INTO BMARK VALUES (pc_event,pc_case, ln_ensec - gn_begintime, ;
    0, 0, pc_tstdat, datet())

  IF pl_dspwait
    WAIT wind "End time recorded..." + str(ln_ensec - gn_begintime,10,5)
  ENDIF

ENDIF


*sele event,case, avg(time1)*1.0 from bmark WHERE DTOC(DT)="04/22/98" group by event,case
