*------------------------------------------------------------------------------
*- Version....: Sage Pro ERP 7.50.00
*- File Name..: $Workfile: PEMPASTE.PRG $
*- VCS Level..: $Revision: 1 $
*- Last Update: $Date: 12/21/06 12:25p $
*------------------------------------------------------------------------------
*- Notice.....: Copyright (c) 1985-1998 SBT Corporation. All rights reserved.
*------------------------------------------------------------------------------
*- App ID.....: Tools
*- App Name...: Developer tools
*------------------------------------------------------------------------------
*- Synopsis...: Tools to paste PEMs
*------------------------------------------------------------------------------
*- Called By..: Command Window or hot key
*------------------------------------------------------------------------------
*- Calls......: SBTPROC (procedure file), others
*------------------------------------------------------------------------------
LOCAL ARRAY	la_SelObj[1], ;
			la_SelectedObjects[1]
			
LOCAL lc_oldpath, ;
      lc_prgpath, ;
      lc_newpath

#include global.h

STORE Cc_Null TO lc_oldpath, ;
                 lc_prgpath, ;
                 lc_newpath

lc_oldpath = SET("PATH")

lc_prgpath = SYS(16)

lc_prgpath = LEFT(lc_prgpath, RAT("\", lc_prgpath))

IF NOT EMPTY(lc_oldpath)
 lc_newpath = lc_oldpath + ","
ENDIF

lc_newpath = lc_newpath + lc_prgpath

SET PATH TO &lc_newpath.

= ASELOBJ(la_SelObj)

IF TYPE("la_SelObj[1].BaseClass") <> "C"
	*-- No object selected. Now use look at mouse position.
	DECLARE la_SelObj[1]
	la_SelObj	= NULL
	
	= AMOUSEOBJ(la_SelObj)
ENDIF

DO CASE
	CASE TYPE("la_selObj[1].BaseClass") <> "C"
		MESSAGEBOX("Mouse not positioned over an object")
	CASE UPPER(la_selObj[1].Name)	= "SCREEN"	
		MESSAGEBOX("Mouse positioned over screen object")

	OTHERWISE
	
		la_SelectedObjects[1]	= la_selObj[1]

		IF TYPE("go_PastePEM.BaseClass") = "C"
			*-- Form is already loaded. Reset the object.

			WITH go_PastePEM		
				.m_InitSelectedObjects(@la_SelectedObjects)
				.m_GetAllPEM()
			ENDWITH

		ELSE

			RELEASE go_PastePEM
			PUBLIC go_PastePEM
			go_PastePEM	= NEWOBJECT("sbtPastePEM", "sbtbldr", "", ;
				@la_SelectedObjects)
		ENDIF

		go_PastePem.Show()
ENDCASE

SET PATH TO &lc_oldpath.

RETURN
*------------------------------------------------------------------------------
*- End Procedure..: $Workfile: PEMPASTE.PRG $
*------------------------------------------------------------------------------
