*--This programs dumps the code and properties of a class into a text file 
*--Useful to compare the changes 
*--PARAMETER : The class library  
*--            Ex: C:\pro65\po\porecp.MNX
*--OUTPUT    : A text file with same name
*--            Ex: C:\pro65\po\porecp.txt
*--
PARAMETERS pc_file

PRIVATE lc_ret
lc_ret = CHR(13) + CHR(10)

LOCAL ll_getfile, ;
      lc_file, ;
      ll_cont, ;
      lc_Outfile  

CLEAR      
ll_getfile = .f.
lc_file = ""
ll_cont = .t.
lc_Outfile = ""

IF PCOUNT() = 0
  ll_cont = .f.
  lc_Outfile = ""
ELSE
  lc_file = UPPER(pc_file)
  lc_file = ALLTRIM(lc_file) + IIF(AT("MNX", lc_file)=0, ".MNX", "")
  ll_cont = FILE(lc_file)
ENDIF

IF ll_cont
  CLOSE ALL
  USE (lc_file) ALIAS a_class
  SELECT a_class
  lc_text = ""
  SCAN FOR !EMPTY(LevelName)
    lc_Text = lc_Text + lc_ret + ;
              name + lc_ret + ;
              "************** COMMAND *************** " + lc_ret  + ;
              command + lc_ret  + ;
              "************** PROCEDURE ****************** " + lc_ret  + ;
              Procedure + lc_ret + ;
              "************** Cleanup ****************** " + lc_ret  + ;
              Cleanup + lc_ret + ;
              "************** SkipFor ****************** " + lc_ret  + ;
              SkipFor + lc_ret 
  ENDSCAN
  lc_Outfile = STRTRAN(lc_file, "MNX", "TXT")
  STRTOFILE(lc_text, lc_Outfile)
  CLOSE ALL
ENDIF
RETURN lc_Outfile 

*--------------------------------------------------------------------
*-- This function arranges the methods in a object in cronological order
FUNCTION l_ArrMeth
PARAMETERS pc_meth
  LOCAL lc_meth, ;
        ln_times
  
  lc_return = ""
  
  CREATE CURSOR ac_temp (MethName C(200), MethSnip M(4))
  FOR ln_times=1 TO OCCURS("ENDPROC", pc_meth)
    SELECT ac_temp
    APPEND BLANK 
    REPLACE MethSnip WITH "PROCEDURE " + STREXTRACT(pc_meth, "PROCEDURE ", "ENDPROC", ln_times) + "ENDPROC"
    REPLACE MethName WITH UPPER(GETWORDNUM(STRTRAN(MethSnip, "PROCEDURE "), 1, lc_ret))
  NEXT
  
  INDEX ON MethName TAG MethName
  SCAN
    lc_return = lc_return + lc_ret + MethSnip + lc_ret
  ENDSCAN

RETURN lc_return 
