*------------------------------------------------------------------------------
*- Version....: Sage Pro ERP 7.50.00
*- File Name..: $Workfile: sqlchgdr.prg $
*- VCS Level..: $Revision: 1 $
*- Last Update: $Date: 12/21/06 12:25p $
*------------------------------------------------------------------------------
*- Copyright (C) 2008 Sage Accpac International, Inc.  All Rights Reserved.
*------------------------------------------------------------------------------
*- Synopsis...: This file is used to update in house sample data that has just
*-              been downloaded from drive K with default drive/directory paths.
*-              It only works on the in house sample data on drive K that is used
*-              for testing by Tech, QA, and Engineering.
*------------------------------------------------------------------------------
LPARAMETERS pl_Silent, ;
            pl_QuitWhenDone

CLEAR

CLOSE ALL

PUBLIC gl_Debug, ;
       gc_dbcname, ;
       gl_doonerr, ;
       gl_erroff, ;
       gc_quote, ;
       gl_visual

gc_quote = "'"
gl_erroff = .t.
gl_visual = .t.

gc_dbcname  = 'prodata'

gc_glob = ""

DO g_setvr

PUBLIC go_SQL AS sbtmgrsql OF sbtsql.vcx
LOCAL lo_login AS syclogin OF sycsconn.vcx

*-- Define local variables
PRIVATE lc_sbtproc

*-- Search for compiled procedure file
lc_sbtproc = l_fulpat("sbtproc.fxp")

*-- If compiled procedure file not found
IF NOT FILE(lc_sbtproc)
  *-- Search for source procedure file
  lc_sbtproc = l_fulpat("sbtproc.prg")
ENDIF

*-- If source or compiled procedure file found
IF FILE(lc_sbtproc)
  *-- Change direct call of sbtproc for SBE
  *-- If procedure file found, open procedure file
  SET PROCEDURE TO (lc_sbtproc)
ENDIF && FILE(lc_sbtproc)

IF NOT g_inilib("C")
  *-- Display alert
  WAIT WINDOW "One or more of the required library files could " + ;
                   "not be loaded."
ENDIF

*-- Load global objects into memory.
g_inigob()

SET CLASSLIB TO SBTSQL ADDITIVE

gl_Debug = .t.

lo_Login = NEWOBJECT("syclogin","sycsconn.vcx")

lo_Login.m_login("ADMN", "ADMN")

PRIVATE lc_PrevRoot, ;
      lc_NewRoot, ;
      ll_Continue

STORE SPACE(0) TO lc_PrevRoot, ;
                  lc_NewRoot

ll_Continue = .t.

IF go_SQL.sc_SQLTypeMain = "F"
  lc_tfile = "SYCINST.DBF"
ELSE
  lc_tfile = go_Sql.sc_SysDbname + "SYCINST"
ENDIF
  
IF NOT go_SQL.m_IsTableFound(lc_tfile)
  MESSAGEBOX(ADDBS(FULLPATH(CURDIR())) + "sycinst.dbf not found.")
  ll_Continue = .f.
ENDIF

IF ll_Continue

  go_SQL.m_OpenTable("a_sycinst", "sycinst", .f., .f., "", .f.)

  lc_PrevRoot = UPPER(ALLTRIM(idosdbf))

  lc_NewRoot = UPPER(FULLPATH(CURD()))

  IF NOT pl_Silent
     ll_Continue = MESSAGEBOX("This tool would update the Pro Series system " + ;
     "tables " + CHR(13) + CHR(10) + ;
     "by changing " + lc_PrevRoot + " to " + lc_NewRoot + ".", 1 + 32 + 0, ;
     "Pro Series Change Root Path") = 1
  ENDIF

ENDIF

IF ll_Continue
  go_SQL.so_CurrentAlias.m_ReplaceBulk("idosdbf WITH STRTRAN(UPPER(idosdbf), lc_PrevRoot, lc_NewRoot), idosndx WITH STRTRAN(UPPER(idosndx), lc_PrevRoot, lc_NewRoot), idosprg WITH STRTRAN(UPPER(idosprg), lc_PrevRoot, lc_NewRoot)", "A")

  go_SQL.m_OpenTable("a_sycdata", "sycdata", .f., .f., "", .f.)
  go_SQL.so_CurrentAlias.m_ReplaceBulk("adosdbf WITH STRTRAN(UPPER(adosdbf), lc_PrevRoot, lc_NewRoot), adosndx WITH STRTRAN(UPPER(adosndx), lc_PrevRoot, lc_NewRoot), adosprg WITH STRTRAN(UPPER(adosprg), lc_PrevRoot, lc_NewRoot)", "A")

  go_SQL.m_OpenTable("a_sycpath", "sycpath", .f., .f., "", .f.)
  go_SQL.so_CurrentAlias.m_ReplaceBulk("cdosdbf WITH STRTRAN(UPPER(cdosdbf), lc_PrevRoot, lc_NewRoot), cdosndx WITH STRTRAN(UPPER(cdosndx), lc_PrevRoot, lc_NewRoot)", "A")

  go_SQL.so_CurrentAlias.m_CloseTable()

  *-- For Customized reports that resides in Pro path
  go_SQL.m_OpenTable("a_syrfcus", "syrfcus", .f., .f., "", .f.)
  go_SQL.so_CurrentAlias.m_ReplaceBulk("cuspath WITH STRTRAN(UPPER(cuspath), lc_PrevRoot, lc_NewRoot)", "A")
  go_SQL.so_CurrentAlias.m_CloseTable()

  *-- For Customized classes that resides in Pro path
  go_SQL.m_OpenTable("a_sydfcus", "sydfcus", .f., .f., "", .f.)
  go_SQL.so_CurrentAlias.m_ReplaceBulk("cuspath WITH STRTRAN(UPPER(cuspath), lc_PrevRoot, lc_NewRoot)", "A")
  go_SQL.so_CurrentAlias.m_CloseTable()

  *-- For Customized forms that resides in Pro path
  go_SQL.m_OpenTable("a_syccsub", "syccsub", .f., .f., "", .f.)
  go_SQL.so_CurrentAlias.m_ReplaceBulk("cuspath WITH STRTRAN(UPPER(cuspath), lc_PrevRoot, lc_NewRoot)", "A")
  go_SQL.so_CurrentAlias.m_CloseTable()

  *-- For Customized reports from Dataviews that resides in Pro path
  go_SQL.m_OpenTable("a_sydbrrp", "sydbrrp", .f., .f., "", .f.)
  go_SQL.so_CurrentAlias.m_ReplaceBulk("rptpath WITH STRTRAN(UPPER(rptpath), lc_PrevRoot, lc_NewRoot)", "A")
  go_SQL.so_CurrentAlias.m_CloseTable()

  CLEAR
ENDIF

IF ll_Continue AND pl_QuitWhenDone
  QUIT
ENDIF

RETURN

*------------------------------------------------------------------------------
*- Function...: l_fulpat()
*------------------------------------------------------------------------------
*- Description: Returns equivalent of FULLPATH() function
*------------------------------------------------------------------------------
*- Synopsis...: The function used to duplicate the behaviour of FULLPATH()
*-              in order to avoid GPF error in the later case
*------------------------------------------------------------------------------
*- Called By..: PRJFIX.PRG
*------------------------------------------------------------------------------
*- Passed:
*- Variables..:
*-
*- Parameters.: pc_file, File Name
*------------------------------------------------------------------------------
*- Returns:
*- Value......: Equalent of FULLPATH() with only first parameter
*------------------------------------------------------------------------------
*- Example:
*-   lc_file = l_FULPAT(lc_table)
*------------------------------------------------------------------------------

FUNCTION l_fulpat

PARAMETERS pc_file

  PRIVATE lc_return

  *-- Setup return value
  lc_return = ""

  DO CASE
    CASE EMPTY(pc_file)
      *-- If file name is blank then return the current directory with drive
      lc_return = SYS(5) + CURDIR()

    CASE LEFT(pc_file,2) = "\\" OR SUBSTR(pc_file,2,1) = ":"
      *-- If full path is given return the path as is
      lc_return = UPPER(ALLTRIM(pc_file))

    CASE LEFT(pc_file,1) = "\"
      *-- If root path is given just add the drive
      lc_return = SYS(5) + UPPER(ALLTRIM(pc_file))

    CASE FILE(pc_file)
      *-- If file name exists, then use LOCFILE() function to get the file
      *-- path. This check avoids popping up the file Open dialog box
      lc_return = LOCFILE(pc_file)
    OTHERWISE
      *-- If file doesn't exist, just return the file with current directory
      *-- to duplicate the FULLPATH() behaviour
      lc_return = SYS(5) + CURDIR() + UPPER(ALLTRIM(pc_file))
  ENDCASE

RETURN lc_return
